<template>
  <div>
    <crumbs title="基础词性类型维护" style="min-width: 980px">
      <el-form :inline="true" class="demo-form-inline">
        <el-form-item label="关系名称：">
          <el-input size="mini" v-model="filter.uniqueName" placeholder="请输入" clearable></el-input>
        </el-form-item>
        <el-form-item label="数字编码：">
          <el-input size="mini" v-model="filter.uniqueName" placeholder="请输入" clearable></el-input>
        </el-form-item>
        <el-form-item label="状态：" class="selectMedicine">
          <el-select size="mini" v-model="filter.status" placeholder="请选择" clearable>
            <el-option v-for="item in stateList" :label="item.name" :value="item.id" :key="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item class="dododo">
          <el-button size="mini" @click="filterDatas">搜索</el-button>
        </el-form-item>
      </el-form>
    </crumbs>
    <div class="contents">
      <el-table :data="list" border style="width: 100%">
  <el-table-column :resizable="false" type="index" :index="indexMethod" label="编号" width="60"></el-table-column>
        <el-table-column :resizable="false" prop="gmtModified" label="词性名称" width="180"></el-table-column>
        <el-table-column :resizable="false" prop="hisName" label="数字编码" show-overflow-tooltip></el-table-column>
        <el-table-column
          :resizable="false"
          prop="uniqueName"
          label="是否支持通用扩展"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column :resizable="false" prop="uniqueName" label="是否允许修改" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="uniqueName" label="是否只有单个词" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="uniqueName" label="状态" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="uniqueName" label="操作人" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="uniqueName" label="操作时间" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="operate" label="操作">
          <template slot-scope="scope">
            <el-button @click="modifyRelation(scope.row)" type="text" size="small">修改</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="pagination pagepage">
        <el-pagination
          :current-page.sync="currentPage"
          @current-change="currentChange"
          background
          :page-size="pageSize"
          :page-sizes="pageSizeArr"
          @size-change="handleSizeChange"
          :layout="pageLayout"
          :total="total"
        ></el-pagination>
      </div>
    </div>
  </div>
</template>

<script>
import api from '@api/icss.js';
import config from '@api/config.js';
import utils from '@api/utils.js';

export default {
  name: 'Fusion', //化验大小项和公表维护
  data: function() {
    return {
      list: [],
      searched: false,
      filter: {
        hisName: '', // 医院诊断名称
        uniqueName: '', //标准诊断名称
        status: ''
      },
      stateList: [
        { id: 1, name: '启用' },
        { id: 0, name: '禁用' }
      ],
      currentPage: 1,
      pageSize: config.pageSize,
      pageSizeArr: config.pageSizeArr,
      pageLayout: config.pageLayout,
      total: 0,
      uploadInfo: '导入'
    };
  },
  created() {
    const that = this;
    //返回时避免参数未赋值就获取列表
    setTimeout(function() {
      that.clearFilter();
      // that.getDataList();
    });
    // 非首页 编辑页返回 设置 this.currentPage
    if (Object.keys(this.$route.params).length !== 0) {
      this.currentPage = this.$route.params.currentPage;
    }
  },
  watch: {
    filter: {
      handler: function() {
        this.searched = false;
      },
      deep: true
    }
  },
  beforeRouteEnter(to, from, next) {
    next(vm => {
      //const pm = to.param;
      Object.assign(vm, to.params);
      vm.inCurrentPage = to.params.currentPage;
    });
  },
  methods: {
    handleSizeChange(val) {
      this.pageSize = val;
      this.currentPage = utils.getCurrentPage(
        this.currentPage,
        this.total,
        this.pageSize
      );
      this.getDataList();
    },

    // 获取列表数据
    getDataList(isTurnPage) {
      const params = this.getFilterItems(isTurnPage);
      this.searched = true;
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });
      api.getFusionPage(params).then(res => {
        loading.close();
        if (res.data.code === '0') {
          this.list = res.data.data && res.data.data.records;
        }
        this.total = res.data.data && res.data.data.total;
        if (this.inCurrentPage !== undefined) {
          this.currentPage = this.inCurrentPage;
          this.inCurrentPage = undefined;
        }
      });
    },

    // 处理列表请求数据参数
    getFilterItems(isTurnPage) {
      //翻页时筛选条件没点确定则清空
      if (isTurnPage && !this.searched) {
        this.clearFilter();
      }
      const param = {
        current: this.inCurrentPage || this.currentPage,
        size: this.pageSize,
        hisName: this.filter.hisName.trim(),
        uniqueName: this.filter.uniqueName.trim(),
        uniqueCode: ''
      };
      return param;
    },

    filterDatas() {
      this.currentPage = 1;
      this.getDataList();
    },

    // 跳转至编辑页面
    modifyRelation(row) {
      // const item = Object.assign({}, row);
      // const pam = this.searched
      //   ? {
      //       currentPage: this.currentPage,
      //       pageSize: this.pageSize,
      //       filter: this.filter
      //     }
      //   : { currentPage: this.currentPage, pageSize: this.pageSize };
      // this.$router.push({
      //   name: 'AddFusion',
      //   params: Object.assign(pam, { isEdit: true, data: item })
      // });
    },
    currentChange(next) {
      this.currentPage = next;
      this.getDataList(true);
      // if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
      //     this.list = this.cacheData[next];
      // } else {
      //     this.getDataList();
      // }
    },
    // 清空搜索参数
    clearFilter() {
      this.filter = {
        hisName: '',
        uniqueName: ''
      };
    },

    indexMethod(index) {
      return (this.currentPage - 1) * this.pageSize + index + 1;
    },
    getTagType(val) {
      return val;
    },
    warning(msg, type) {
      this.$message({
        showClose: true,
        message: msg,
        type: type || 'warning'
      });
    }
  }
};
</script>


<style lang="less">
@import '../../less/admin.less';
.delete {
  color: red;
}
.delete:hover {
  color: red;
}
.pagination {
  min-width: 1010px;
}
.downTemplate {
  margin-right: 8px;
  span {
    color: #02a7f0;
  }
}
#upFile {
  display: none !important;
}
.el-message-box {
  /deep/.cancelBtn {
    background-color: #d7d7d7;
    border-color: transparent;
  }
  /deep/.confirmC {
    background-color: #ff545b !important;
    border-color: transparent !important;
  }
}
.exportBox6 {
  /deep/ .el-message-box__btns {
    margin-top: 20px;
  }
  /deep/ .el-message-box__message {
    // text-align: center;
  }
  /deep/.leftbtn {
    background-color: #d7d7d7;
    border-color: transparent !important;
  }
  /deep/ .el-message-box__header {
    border-bottom: 1px solid #dcdfe6;
  }
}
</style>